import * as _tiptap_core from '@tiptap/core';
import { CodeBlockOptions as CodeBlockOptions$1 } from '@tiptap/extension-code-block';
import { LanguageRegistration, ThemeRegistrationRaw, HighlighterCore } from 'shiki/core';

interface CodeBlockOptions extends CodeBlockOptions$1 {
    languages: LanguageRegistration[][];
    themes: {
        light: ThemeRegistrationRaw;
        dark: ThemeRegistrationRaw;
    };
}
interface CodeBlockStorageLanguage {
    name: string;
    displayName: string;
}
interface CodeBlockStorage {
    highlighter: HighlighterCore;
    languages: CodeBlockStorageLanguage[];
}
declare const codeBlock: _tiptap_core.Node<CodeBlockOptions, CodeBlockStorage>;

export { type CodeBlockOptions, type CodeBlockStorage, type CodeBlockStorageLanguage, codeBlock };
